using Xamarin.Forms;
using Syncfusion.SfChart.XForms.Droid;
using Xamarin.Forms.Platform.Android;
using Com.Syncfusion.Charts;
using DataMarkerSample;
using Syncfusion.SfChart.XForms;
using System;

[assembly: ExportRenderer(typeof(ChartExt), typeof(DataMarkerSample.Droid.CustomRenderer))]

namespace DataMarkerSample.Droid
{
    public class CustomRenderer : SfChartRenderer
    {
        public CustomRenderer()
        {
        }

        protected override void OnElementChanged(ElementChangedEventArgs<Syncfusion.SfChart.XForms.SfChart> e)
        {
            base.OnElementChanged(e);
            if (Control != null)
            {
                for (int i = 0; i < Control.Series.Size(); i++)
                {
                    (Control.Series.Get(i) as Com.Syncfusion.Charts.ChartSeries).DataMarkerLabelCreated += CustomRenderer_DataMarkerLabelCreated;
                }
            }
        }

        private void CustomRenderer_DataMarkerLabelCreated(object sender, Com.Syncfusion.Charts.ChartSeries.DataMarkerLabelCreatedEventArgs e)
        {
            for (int i = 0; i < Control.Series.Size(); i++)
            {
                if (Convert.ToInt32(e.P0.Label) >= SplineSample.chart.Range)
                {
                    (Control.Series.Get(i) as Com.Syncfusion.Charts.ChartSeries).DataMarker.LabelStyle.BackgroundColor = Android.Graphics.Color.Red;
                   
                }
                else
                {
                    (Control.Series.Get(i) as Com.Syncfusion.Charts.ChartSeries).DataMarker.LabelStyle.BackgroundColor = Android.Graphics.Color.Blue;
                }
            }
        }
    }
}

