﻿using DataMarkerSample;
using Syncfusion.SfChart.XForms.UWP;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms.Platform.UWP;
using Syncfusion.SfChart.XForms;
using NativeChart = Syncfusion.UI.Xaml.Charts;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Markup;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Media;
using Windows.UI;

[assembly: ExportRenderer(typeof(ChartExt), typeof(DataMarkerSample.UWP.CustomRenderer))]
namespace DataMarkerSample.UWP
{
    public class CustomRenderer : SfChartRenderer
    {
        protected override void OnElementChanged(ElementChangedEventArgs<SfChart> e)
        {
            base.OnElementChanged(e);
            foreach (NativeChart.SplineSeries series in Control.Series.OfType<NativeChart.SplineSeries>().Where(series => series.AdornmentsInfo != null))
            {
                series.AdornmentsInfo.SegmentLabelContent = NativeChart.LabelContent.LabelContentPath;
                StringBuilder stringBuilder = new StringBuilder();
                stringBuilder.Append(" <DataTemplate x:Key=\"dateMarkerTemplate\" xmlns=\"http://schemas.microsoft.com/winfx/2006/xaml/presentation\" ");
                stringBuilder.Append(" xmlns:x=\"http://schemas.microsoft.com/winfx/2006/xaml\"");
                stringBuilder.Append(" xmlns:local=\"using:DataMarkerSample.UWP\">");
                stringBuilder.Append(" <Border><Border.Background><Binding><Binding.Converter><local:AdornmentLabelConverter></local:AdornmentLabelConverter></Binding.Converter></Binding></Border.Background><TextBlock Text=\"{Binding Item.YValue}\"></TextBlock></Border>");
                stringBuilder.Append(" </DataTemplate>");
                series.AdornmentsInfo.LabelTemplate = (DataTemplate)XamlReader.Load(stringBuilder.ToString());

            }
        }
    }
    [Bindable]
    public class AdornmentLabelConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            var data = value as NativeChart.ChartAdornment;
            if (data.YData >= SplineSample.chart.Range)
                return new SolidColorBrush(Colors.Red);
            return new SolidColorBrush(Colors.Blue);
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }
    }
}
